// fcsub.c
#include "fcsub.h"

unsigned int rndwork;   // ^

// S@\̏
void fc_init(void)
{
  ppu_vsync();      // VuN҂
  ppu_enable(0);    // \𖳌
  rndwork = 0x005a; // ^̃V[hlݒ
  sound_init();     // TEh̏
  bg_cls();         // BG̏
  sp_cls();         // XvCg̏
  bg_scroll(0, 0);  // BGXN[ݒ
}

// PPUAhXݒ(AhX0x0000`0xffff)
void ppu_address(unsigned short adr)
{
  PPUADDR = adr >> 8;   // AhX8bit
  PPUADDR = adr & 0xff; // AhX8bit
}

// BG̏
void bg_cls(void)
{
  short i;
  ppu_address(0x2000);
  for(i=0; i<0x800; i++){
    // l[e[uƃAgr[g̏
    PPUDATA = 0;  
  }
}

// XvCg̏
void sp_cls(void)
{
  char i;
  for(i=0; i<16; i++){
    sp_remove(i);  // XvCgʊO
  }
}

// ^̎擾
unsigned int random(void)
{
  rndwork ^= (rndwork << 3);
  rndwork ^= (rndwork >> 5);
  rndwork ^= (rndwork << 4);
  return(rndwork);   // ߂l=0`0xffff
}

// Rg[[1
unsigned char controller1(void)
{
  unsigned char ret=0;
  char i;
  JOYPAD1 = 0x01;  // {^͂Jn
  JOYPAD1 = 0x00;  // {^͂b`
  for(i=0; i<8; i++){
    ret <<= 1;
    // {^ꂽ
    if( JOYPAD1 & (1<<0) ) ret |= 1;  
  }
  return(ret);  // ߂l={^̏(8bit)
}

// TEh
void sound_init(void)
{
  #define DUTY 2   // g`̃f[eBݒ(2=50%)
  #define VOLUME 8 // ̃{[(0`15)
  #define SHIFT 2  // gω(0`7)
  #define DIVID 4  // gω(0`7)
  #define DIR 1    // gω@(1=ɕω)
  // `g1䃌WX^1 
  PULSE1CTR1 = (DUTY<<6)+(1<<5)+(1<<4)+VOLUME;  
  // `g1䃌WX^2
  PULSE1CTR2 = (1<<7)+(DIVID<<4)+(DIR<<3)+SHIFT;   
  SNDCHANNEL = (1<<0);  // `g1݂̂gp
}

// `g1Đ(g)
void pulse1(unsigned short hz)
{
  unsigned short tmp;
  tmp = (unsigned short)((1790000/16)/hz)-1;
  // `g1g1(bit7`0)
  PULSE1FREQ1 = tmp & 0xff;
  // `g1g2(bit10`8) 
  PULSE1FREQ2 = tmp >> 8;  
}

// J[pbgݒ
// (i[|C^, ItZbg0`7, pbg1`8)
void ppu_palette(char *ptable, char ofs, char size)
{
  size *= 4;   // 1pbg4oCg
  // J[pbg̃AhX
  ppu_address(0x3f00+(ofs*4));  
  while(size--){
    PPUDATA = *ptable++;
  }
}

// p^[e[uݒ
// (i[|C^, ItZbg0`511, 1`512)
void ppu_pattern(unsigned char *ptable, short ofs, short size)
{
  size *= 16;   // 116oCg
  ppu_address(ofs*16);   // p^[e[ũAhX
  while(size--){
    PPUDATA = *ptable++;
  }
}

// ʕ\̗L(1=\ONA0=\OFF)
void ppu_enable(char on)
{
  // PPU}XN(bit4=SPLAbit3=BGL)
  PPUMASK = on*((1<<4)+(1<<3))+6;  
}

// VuN҂
void ppu_vsync(void)
{
  // bit70̏ꍇAʕ`撆
  while((PPUSTATUS & (1<<7))==0);  
}

// BGXN[ݒ
// (XWItZbg0`511, YWItZbg0`239)
void bg_scroll(unsigned short x, unsigned char y)
{
  PPUSCROLL = (x & 0xff);   // XW(0`255)
  PPUSCROLL = y;            // YW
  // XW256ȏ̏ꍇ͉B
  PPUCTRL = 0x08+((x >> 8)& 1);  
}

// BGLN^\
// (XW0`31, YW0`29, ^Cԍ0`255)
void bg_printch(char x, char y, unsigned char c)
{
  // UƂāAYW32`61̏ꍇ
  // Bɏ݂ł
  //l[e[ũAhX
  ppu_address( 0x2000+x+((unsigned short)y*32) );  
  PPUDATA = c;
}

// BG\(XW0`31, YW0`29, |C^)
void bg_printstr(char x, char y, char *str)
{
  //l[e[ũAhX
  ppu_address(0x2000+x+((unsigned short)y*32));  
  while (*str != 0){
    PPUDATA = *str++;
  }
}

// BGAgr[gݒ
// (XW0`31, YW0`29, Agr[g0`255)
void bg_attrib(char x, char y, unsigned char atr)
{
  // BGAgr[g̃AhX
  ppu_address(0x23C0+(x/4)+((y/4)*8));  
  PPUDATA = atr;
}

// 10i5P^ϊ(i[|C^, l0`65535)
void num_to_str(char *str, unsigned short num)
{
  char i;
  for(i=4;;i--){
    str[i] = (num % 10)+'0';
    num /= 10;
    if(i==0)break;
  }
  str[5] = 0; // NULL
}

// 16i2P^ϊ(i[|C^, l0`255)
void num_to_hex(char *str, unsigned char num)
{
  unsigned char tmp;
  tmp = '0'+(num >> 4);             // 0`9ɕϊ
  if(tmp > '9') tmp += 'A'-('9'+1); // A`Fɕϊ
  str[0] = tmp;                     // 4bit
  tmp = '0'+(num & 0x0f);           // 0`9ɕϊ
  if(tmp > '9')tmp += 'A'-('9'+1);  // A`Fɕϊ
  str[1] = tmp;                     // 4bit
  str[2] = 0;                       // NULL
}

// XvCg[NDMA]Jn
void sp_dmastart(void)
{
  OAMADDR = 0;            // ]OAMAhX
  OAMDMA = SPWADDR >> 8;  // ]AhX8bit
}

// XvCg4 ǉ
// (XW,YW, ^C0`255, Agr[g0`255)
char sp_append(char x, char y, char tile, char attr)
{
  char i;
  for(i=0; i<16; i++){
    if(sp_gety(i)==OUTSIDE){
      sp_ofs(i, x,y);
      sp_chr(i, tile,attr);
      break;
    }
  }
  return(i);
}

// XvCg4 (XvCgԍ0`15)
void sp_remove(char i)
{
  sp_ofs(i,OUTSIDE,OUTSIDE);  // XvCgʊO
}

// XvCg4 \ύX
// (XvCgԍ0`15, ^C0`255, Agr[g0`255)
void sp_chr(char num, unsigned char tile, unsigned char attr)
{
  unsigned char *ptr;
  // XvCg[N݃AhX
  ptr = (unsigned char *)SPWADDR+(num*4); 
  ptr[1+(64*0)] = tile;   // XvCgnum+0 ^Cԍ
  ptr[2+(64*0)] = attr;   // XvCgnum+0 Agr[g
  ptr[1+(64*1)] = tile+1; // XvCgnum+1 ^Cԍ
  ptr[2+(64*1)] = attr;   // XvCgnum+1 Agr[g
  ptr[1+(64*2)] = tile+2; // XvCgnum+2 ^Cԍ
  ptr[2+(64*2)] = attr;   // XvCgnum+2 Agr[g
  ptr[1+(64*3)] = tile+3; // XvCgnum+3 ^Cԍ
  ptr[2+(64*3)] = attr;   // XvCgnum+3 Agr[g
}

// XvCg4 Aj(XvCgԍ0`15)
void sp_anime(char num)
{
  unsigned char *ptr;
  // XvCg[NAhX
  ptr = (unsigned char *)SPWADDR+(num*4); 
  ptr[1+(64*0)] ^= 4;   // XvCgnum+0 ^Cԍ
  ptr[1+(64*1)] ^= 4;   // XvCgnum+1 ^Cԍ
  ptr[1+(64*2)] ^= 4;   // XvCgnum+2 ^Cԍ
  ptr[1+(64*3)] ^= 4;   // XvCgnum+3 ^Cԍ
}

// XvCg4 ړ
// (XvCgԍ0`15, XW0`255, YW0`255)
void sp_ofs(char num, unsigned char x, unsigned  char y)
{
  unsigned char *ptr;
  // XvCg[NAhX
  ptr = (unsigned char *)SPWADDR+(num*4); 
  ptr[0+(64*0)] = y;     // XvCgnum+0 YW
  ptr[3+(64*0)] = x;     // XvCgnum+0 XW
  ptr[0+(64*1)] = y;     // XvCgnum+1 YW
  ptr[3+(64*1)] = x+8;   // XvCgnum+1 XW
  ptr[0+(64*2)] = y+8;   // XvCgnum+2 YW
  ptr[3+(64*2)] = x;     // XvCgnum+2 XW
  ptr[0+(64*3)] = y+8;   // XvCgnum+3 YW
  ptr[3+(64*3)] = x+8;   // XvCgnum+3 XW
}

// XvCgXW擾(XvCgԍ0`63)
unsigned char sp_getx(char num)
{
  return(*((unsigned char *)SPWADDR+3+(num*4)));
}

// XvCgYW擾(XvCgԍ0`63)
unsigned char sp_gety(char num)
{
  return(*((unsigned char *)SPWADDR+0+(num*4)));
}

// XvCg̃^C擾(XvCgԍ0`63)
unsigned char sp_gettile(char num)
{
  // ߂l=^Cԍ
  return(*((unsigned char *)SPWADDR+1+(num*4))); 
}

// XvCgՓ˔(XvCgԍ0`63, XW, YW)
char sp_hitcheck(char num, unsigned char x, unsigned char y)
{
  unsigned char *ptr;
  // XvCg[NAhX
  ptr = (unsigned char *)SPWADDR+(num*4); 
  x += 16;
  y += 16;
  y -= ptr[0];   // YW
  x -= ptr[3];   // XW
  // ߂l=1̏ꍇAՓ˂
  if((y < 32)&&(x < 32)) return(1);  
  return(0);  // 0̏ꍇAՓ˂Ȃ
}
