// main.c
#include "fcsub.h"   // t@~RpCu
#include "pattern.h" // p^[e[upf[^

void pushbutton(void);
void title(void);
void result(void);
void player(char num, unsigned char x, unsigned char y);
void coin(char num, unsigned char x, unsigned char y);
void monster(char num, unsigned char x, unsigned char y);
char NesMain(void);

const char colortable[] = { // J[e[u
  C_SKYBLUE, C_GREEN, C_LIMEGREEN, C_WHITE ,
  C_SKYBLUE, 0      , 0          , 0       ,
  C_SKYBLUE, 0      , 0          , 0       ,
  C_SKYBLUE, 0      , 0          , 0       ,
  C_SKYBLUE, C_BLUE , C_RED      , C_YELLOW,
  C_SKYBLUE, C_BLACK, C_LIGHTGRAY, C_WHITE ,
  C_SKYBLUE, 0      , 0          , 0       ,
  C_SKYBLUE, 0      , 0          , 0        
};

const unsigned char strtitle[] = "JUMP GAME";
const unsigned char strpush[]  = "PUSH ANY BUTTON";
const unsigned char strgover[] = "GAME OVER";
const unsigned char strscore[] = "SCORE";

// O[oϐ
short score;            // XRA
unsigned char gameover; // Q[I[o[JE^
signed char jump;       // vC[̃Wvړ
unsigned short bgx;     // BGItZbgW
unsigned char loopcnt;  // [vJE^
unsigned char level;    // ՓxiG̏oxj

// {^̓͑҂
void pushbutton(void)
{
  unsigned char newbtn, oldbtn, edge;

  ppu_enable(1);  // ʕ\L
  oldbtn = 0;
  edge = 0;
  while (edge < 2) {
    newbtn = controller1();  // Rg[[1
    if (oldbtn != newbtn) { edge++; } // {^̃GbWo
    oldbtn = newbtn;
    ppu_vsync();     // VuN҂
    sp_dmastart();   // OMA DMA]Jn
    bg_scroll(0,0);  // BGXN[
  }
  ppu_enable(0);  // \𖳌
  pulse1(300);    // `g1TEhĐ
  bg_cls();       // BGS
  sp_cls();       // XvCgS
}

// ^Cg
void title(void)
{
  char x, y, tilenum;
  
  // "JUMP GAME"\
  bg_printstr(11, 10, (unsigned char *)strtitle); 
  // "PUSH ANY BUTTON"\
  bg_printstr(8, 18, (unsigned char *)strpush);   
  pushbutton();  // {^̓͑҂
  for (y = 20; y < 30; y++) {
    for (x = 0; x < 32; x++) {
      tilenum = ((x + y) & 1) + 1;    // ^Cԍ
      bg_printch(x, y, tilenum);      // BG Aɕ`
      bg_printch(x, y + 32, tilenum); // BG Bɕ`
    }
  }
  sp_append(64, 120, 0, 0); // vC[ǉ
  score = 0;      // XRA
  jump = 0;       // Wvړ
  gameover = 0;   // Q[I[o[JE^
  bgx = 0;        // BGItZbgW
  loopcnt = 0;    // [vJE^
  level = 50;     // Փx
  ppu_enable(1);  // \L
}

// Q[I[o[
void result(void)
{
  unsigned char tmpstr[6];

  ppu_enable(0);  // \𖳌
  bg_cls();       // BGS
  sp_cls();       // XvCgS
  // "GAME OVER"\
  bg_printstr(11, 11, (unsigned char *)strgover); 
  // "SCORE"\
  bg_printstr(10, 15, (unsigned char *)strscore); 
  num_to_str(tmpstr, score);    // XRA𕶎
  bg_printstr(16, 15, tmpstr);  // XRA\
  pushbutton();  // {^̓͑҂
}

// vC[̈ړ
void player(char num, unsigned char x, unsigned char y)
{
  unsigned char btn;   // {^

  btn = controller1();   // Rg[[1
  // 
  if (((btn & BUTTON_LEFT ) != 0)&&(x > 8  )) { x -= 2; }
  // E
  if (((btn & BUTTON_RIGHT) != 0)&&(x < 228)) { x += 2; }
  // Wv
  if ((y >= 144) && ((btn & BUTTON_A)!=0)) { jump = -31; } 
  if (jump < 31) {
    jump++;              // d͂ɂ
    // A{^ĂȂꍇ
    if ((btn & BUTTON_A)==0) { jump += 2; } 
  }
  y += (jump >> 2);
  if (y > 144) { y = 144; } // nʂւ̂߂荞ݖh~
  sp_ofs(num, x, y);
}

// RC̈ړ
void coin(char num, unsigned char x, unsigned char y)
{
  x--;
  // vC[ƏՓˁH
  if ((gameover==0) && (sp_hitcheck(0, x, y)==1)) {  
    y = OUTSIDE;  // RCʊO
    pulse1(500);  // `g1TEhĐ
    score++;      // XRAZ
  }
  sp_ofs(num, x, y);  // XvCg̈ړ
}

// IoP̈ړ
void monster(char num, unsigned char x, unsigned char y)
{
  x--;
  x -= (num % 3);
  sp_ofs(num, x, y);
  // vC[ƏՓˁH
  if ((gameover==0) && (sp_hitcheck(0, x, y)==1)) {  
    sp_remove(0);  // vC[
    pulse1(250);   // `g1TEhĐ
    gameover = 1;  // Q[I[o[
  }
}

// C֐
char NesMain(void)
{
  unsigned char i, x, y;

  fc_init();    // i1jS@\̏
  // i2jp^[e[u̐ݒ
  ppu_pattern((unsigned char *)pattern, 0, 512);
  // i3jJ[pbg̐ݒ  
  ppu_palette((char *)colortable, 0, 8);  
  while (1) {
	title();   // i4j^Cgʂ̕\
	// i5jQ[[vivCj
    while (gameover < 180) {
      for (i = 0; i < 16; i++) {
        y = sp_gety(i);
        // ʊÕXvCgXLbv
        if (y == OUTSIDE) { continue; } 
        x = sp_getx(i);
        // XvCgʊOɂꍇ͏
        if (x <= 1) {
          sp_remove(i); 
          continue;
        }
        // ^Cԍŏ𕪊
        switch (sp_gettile(i) >> 3) { 
        case 0:
          player(i, x, y);  // vC[ړ
          break;
        case 1:
          coin(i, x, y);    // RCړ
          break;
        case 2:
          monster(i, x, y); // IoPړ
          break;
        }
      }
      loopcnt++;
      if ((loopcnt & 63)==0) {
        y = (random() % 9) * 16 + 15;
        sp_append(240, y, 8, 0); // RC̒ǉ
        if (level < 255) { level++; } // Փxグ
      }
      if ((loopcnt & 15)==0 ) {
        if ((random() & 255) <= level) {
          y = (random() % 9) * 16 + 15;
          sp_append(240, y, 16, 1); // IoP̒ǉ
        }
      }
      sp_anime(loopcnt & 15);
      if (gameover) { gameover++; }
      bgx = (bgx + 1) & 511;  // BGItZbgWύX
      ppu_vsync();            // VuN҂
      sp_dmastart();          // OMA DMA]Jn
      bg_scroll(bgx,0);       // BGXN[
    }
    result();   // i6jQ[I[o[ʂ̕\
  }
  return 0;
}

